follow2_chrome();

/* Constructor */
function follow2_chrome()
{
    /* System Preferences */
    this.follow2_sys_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.follow2.sys.");
    /* DB Connection */
    this.follow2_dbfile=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD",Components.interfaces.nsIFile);
    this.follow2_dbfile.append("follow2-feeds.sqlite");
    this.follow2_storage_service=Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
    this.follow2_conn=this.follow2_storage_service.openDatabase(this.follow2_dbfile);
    var firstCreate=false;
    if(!this.follow2_conn.tableExists("feedsdb")) firstCreate=true;
    this.follow2_conn.executeSimpleSQL("create table if not exists feedsdb(id integer primary key asc,feed_id integer,url text,title text,lasttitle text,favicon text,unique(url),unique(feed_id))");
    if(firstCreate) follow2_insertDefaultFeeds();
    /* Initialize Variables */
    this.follow2_curLoc = null;
    this.follow2_blockNotifier = false;
    /* Initialize Events */
    window.addEventListener("load",function()
    {
        gBrowser.addEventListener("load",follow2_onSelectTab,true);
        gBrowser.addEventListener("select",follow2_onSelectTab,false);
    },false);
    /* Initialize Inspector */
    follow2_insepector=setInterval(function(){follow2_inspect();},this.follow2_sys_prefs.getIntPref("inspector.interval"));
    follow2_suspendedNotification=setInterval(function(){follow2_suspendedNotify();},this.follow2_sys_prefs.getIntPref("inspector.suspended-notifier"));
}
/* Events */
function follow2_onSelectTab(event)
{
    if(_content.document.URL!=null&&_content.document.URL!=this.follow2_curLoc&&_content.document.URL!="about:blank")
    {
        this.follow2_curLoc = _content.document.URL;
        if(window.follow2_blockNotifier)
        {
            clearTimeout(window.follow2_submitNotificationTimeout);
            window.follow2_blockNotifier=false;
            follow2_suspendedNotify();
        }
        if (document.getElementById("follow2-caption").getAttribute("label").indexOf(document.getElementById("follow2-stringbundle").getString("follow2-overlay-caption-updated")) == -1)
        //If there is no update notification
            follow2_initFeeds();
        else if((this.follow2_newFeeds = follow2_getFeeds()).length != 0)
        {
        //If there is an update notification, and there are feeds to get updated from current site
            follow2_setAdditionalIcon();
            follow2_setSubmitNotification();
        }
        //If there is an update notification, but no feeds to get updated from current site
        else follow2_rmvAdditionalIcon();
    }
}
/* Inspector */
function follow2_getInspectFeeds()
{
    var feedValidaterParameters = "";
    var index=0;
    this.follow2_inspectFeeds=new Array();
    this.follow2_statement=this.follow2_conn.createStatement("select * from feedsdb");
    while(follow2_statement.executeStep())
        if (follow2_statement.getString(0) != null &&
            follow2_statement.getString(1) != null &&
            follow2_statement.getString(2) != null &&
            follow2_statement.getString(3) != null &&
            follow2_statement.getString(4) != null)
        {
            this.follow2_inspectFeeds[index] = new Array();
            this.follow2_inspectFeeds[index]["id"] = follow2_statement.getString(0);
            this.follow2_inspectFeeds[index]["feedId"] = follow2_statement.getString(1);
            this.follow2_inspectFeeds[index]["url"] = follow2_statement.getString(2);
            this.follow2_inspectFeeds[index]["title"] = follow2_statement.getString(3);
            this.follow2_inspectFeeds[index]["lasttitle"] = follow2_statement.getString(4);
            this.follow2_inspectFeeds[index]["favicon"] = follow2_statement.getString(5);
            feedValidaterParameters += "url" + index + "=" + follow2_URLEncode(follow2_statement.getString(2)) + "&";
            index++;
        }
    feedValidaterParameters = feedValidaterParameters.substr(0, feedValidaterParameters.length - 1);
    return feedValidaterParameters;
}
function follow2_inspect() {
    //if (this.follow2_suspendedUpdates != null) if (this.follow2_suspendedUpdates.length > 0) return; //Was a bug
    var feedValidaterParameters=follow2_getInspectFeeds();
    follow2_ajax_request_inspect(this.follow2_sys_prefs.getCharPref("serv.dir") + this.follow2_sys_prefs.getCharPref("serv.validater"), feedValidaterParameters);
}
function follow2_inspectorChecker(response) {
    follow2_getInspectFeeds();
    var responseFeeds=response.split('\n');
    if (responseFeeds.length != this.follow2_inspectFeeds.length) return;
    for(var index=0;index<responseFeeds.length;index++) {
        var feed=responseFeeds[index].split(',');
        if (feed[3] != "0" && this.follow2_inspectFeeds[index]["url"] == feed[0])
            if (feed[2] != this.follow2_inspectFeeds[index]["lasttitle"]) if (follow2_addingSuspendedAvailable(this.follow2_inspectFeeds[index]["title"])) follow2_addUpdatedFeed(feed[0], feed[1], feed[2], feed[3], feed[4]);
    }
}
function follow2_suspendedNotify()
{
    if(!this.follow2_blockNotifier)
    {
        if (this.follow2_suspendedUpdates != null)
            if (this.follow2_suspendedUpdates.length > 0) {
                follow2_notifyUpdated(this.follow2_sys_prefs.getCharPref("serv.viewer-prefix") + this.follow2_suspendedUpdates[0]["feedId"] + this.follow2_sys_prefs.getCharPref("serv.viewer-suffix"), this.follow2_suspendedUpdates[0]["title"], this.follow2_suspendedUpdates[0]["favicon"]);
                return true;
            }
        return false;
    }
}
function follow2_addingSuspendedAvailable(title) {
    if (this.follow2_suspendedUpdates == null) return true;
    for (var index = 0; index < this.follow2_suspendedUpdates.length; index++)
        if (this.follow2_suspendedUpdates[index]["title"] == title) return false;
    return true;
}
function follow2_showFeedsList()
{
    if(this.follow2_feedsList==null||this.follow2_feedsList.closed)
        this.follow2_feedsList=window.openDialog("chrome://follow2/content/follow2-feeds-list.xul",null,"centerscreen,height="+this.follow2_sys_prefs.getIntPref("feeds-list.height")+"px,width="+this.follow2_sys_prefs.getIntPref("feeds-list.width")+"px", follow2_getAllFeeds(), this.follow2_sys_prefs, this.follow2_conn);
    else this.follow2_feedsList.focus();
}
function follow2_getAllFeeds()
{
    this.follow2_statement=this.follow2_conn.createStatement("select * from feedsdb");
    var allFeeds=new Array();
    var index=0;
    while(follow2_statement.executeStep())
        if (follow2_statement.getString(0) != null &&
            follow2_statement.getString(1) != null &&
            follow2_statement.getString(2) != null &&
            follow2_statement.getString(3) != null &&
            follow2_statement.getString(4) != null)
        {
            allFeeds[index] = new Array();
            allFeeds[index]["id"] = follow2_statement.getString(0);
            allFeeds[index]["feedId"] = follow2_statement.getString(1);
            allFeeds[index]["url"] = follow2_statement.getString(2);
            allFeeds[index]["title"] = follow2_statement.getString(3);
            allFeeds[index]["lasttitle"] = follow2_statement.getString(4);
            allFeeds[index]["favicon"] = follow2_statement.getString(5);
            index++;
        }
    return allFeeds;
}
function follow2_insertDefaultFeeds()
{
    var defFeeds=new Array(
        "http://www.foxbusiness.com/index.html",
        "http://www.businessweek.com//index.html",
        "http://www.bikeforums.net/",
        "http://www.sitepoint.com/forums/",
        "http://www.flickr.com/photos/tags/travel/"
    );
    
    var feedValidaterParameters = "";
    if(defFeeds.length==0) return false;
    for(var index=0;index<defFeeds.length;index++)
    {
        feedValidaterParameters += "url" + index + "=" + follow2_URLEncode(defFeeds[index]);
        if (index < defFeeds.length - 1) feedValidaterParameters += "&";
    }
    follow2_ajax_request_submit(this.follow2_sys_prefs.getCharPref("serv.dir") + this.follow2_sys_prefs.getCharPref("serv.validater"), feedValidaterParameters, true);
}
function follow2_getCurrentSiteName()
{
    return follow2_getSiteName(_content.document.URL);
}
function follow2_getSiteName(siteName)
{
    siteName=siteName.replace("http://","");
    siteName=siteName.replace("https://","");
    siteName=siteName.replace("www.","");
    siteName=siteName.replace(/\/(.*)/i,"")
    return siteName;
}
function follow2_getCurrentFeedName()
{
    return follow2_getFeedName(_content.document.URL);
}
function follow2_getFeedName(siteName)
{
    var matches=siteName.match(/[^\/]*\/\/([^\/]*)\/?([^\/]*)\//i);
    if(matches[1]==null) matches[1]=follow2_getSiteName(siteName);
    if(matches[2]==null||matches[2]=="") matches[2]="";
    else matches[2]=" ["+matches[2]+"]";
    return matches[1]+matches[2];
}
function follow2_URLEncode(url) {
    var SAFECHARS = "0123456789" +
"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +
"abcdefghijklmnopqrstuvwxyz" +
"-_.!~*'()";
    var HEX = "0123456789ABCDEF";

    var plaintext = url;
    var encoded = "";
    for (var i = 0; i < plaintext.length; i++) {
        var ch = plaintext.charAt(i);
        if (ch == " ") {
            encoded += "+";
        } else if (SAFECHARS.indexOf(ch) != -1) {
            encoded += ch;
        } else {
            var charCode = ch.charCodeAt(0);
            if (charCode > 255) {
                alert("Unicode Character '"
+ ch
+ "' cannot be encoded using standard URL encoding.\n" +
"(URL encoding only supports 8-bit characters.)\n" +
"A space (+) will be substituted.");
                encoded += "+";
            } else {
                encoded += "%";
                encoded += HEX.charAt((charCode >> 4) & 0xF);
                encoded += HEX.charAt(charCode & 0xF);
            }
        }
    }

    return encoded;
}